<template>
  <div id="contact-table">
    <p v-if="contacts.length < 1" class="empty-table">No Contacts</p>
    <table>
      <!-- ...thread... -->
      <tbody>
        <tr v-for="contact in contacts" :key="contact.id">
          <td v-if="editing === contact.id">
            <input type="text" v-model="contact.name" />
          </td>
          <td v-else>{{contact.name}}</td>
          <td v-if="editing === contact.id">
            <input type="text" v-model="contact.email" />
          </td>
          <td v-else>{{contact.email}}</td>
          <td v-if="editing === contact.id">
            <button @click="editContact(contact)">Save</button>
            <button class="muted-button" @click="cancelEdit(contact)">Cancel</button>
          </td>
          <td v-else>
            <button @click="editMode(contact)">Edit</button>
            <button @click="$emit('delete:contact', contact.id)">Delete</button>
          </td>
        </tr>
      </tbody>
    </table>
  </div>
</template>

<script>
export default {
  name: "contact-table",
  props: {
    contacts: Array
  },
  data() {
    return {
      editing: null
    };
  },
  methods: {
    editMode(contact) {
      this.cachedContact = Object.assign({}, contact);
      this.editing = contact.id;
    },
    cancelEdit(contact) {
      Object.assign(contact, this.cachedContact);
      this.editing = null;
    },
    editContact(contact) {
      if (contact.name === "" || contact.email === "") return;
      this.$emit("edit:contact", contact.id, contact);
      this.editing = null;
    }
  }
};
</script>

<style scoped>
button {
  margin: 0.5rem 0.75rem 0 0;
}
</style>